Index: conf.c
===================================================================
--- conf.c	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ conf.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,6 +1,6 @@
-/********************************************************************\
+  /********************************************************************\
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
-  * Copyright 2002-2005 Wilmer van der Gaast and others                *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
   \********************************************************************/
 
@@ -20,6 +20,6 @@
   You should have received a copy of the GNU General Public License with
   the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
-  if not, write to the Free Software Foundation, Inc., 51 Franklin St.,
-  Fifth Floor, Boston, MA  02110-1301  USA
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
 */
 
@@ -32,363 +32,250 @@
 #include "ini.h"
 #include "url.h"
-#include "ipc.h"
-
-#include "proxy.h"
-
-static int conf_loadini(conf_t *conf, char *file);
-static void conf_free(conf_t *conf);
-
-conf_t *conf_load(int argc, char *argv[])
+
+#include "protocols/proxy.h"
+
+char *CONF_FILE;
+
+static int conf_loadini( conf_t *conf, char *file );
+
+conf_t *conf_load( int argc, char *argv[] )
 {
 	conf_t *conf;
-	int opt, i, config_missing = 0;
-	int version_happened = 0;
-
-	conf = g_new0(conf_t, 1);
-
-	conf->iface_in = NULL;
-	conf->iface_out = NULL;
-	conf->port = g_strdup("6667");
+	int opt, i;
+	
+	conf = g_new0( conf_t, 1 );
+	
+	conf->iface = "0.0.0.0";
+	conf->port = 6667;
 	conf->nofork = 0;
 	conf->verbose = 0;
-	conf->primary_storage = g_strdup("xml");
-	conf->migrate_storage = g_strsplit("text", ",", -1);
 	conf->runmode = RUNMODE_INETD;
 	conf->authmode = AUTHMODE_OPEN;
-	conf->auth_backend = NULL;
-	conf->auth_pass = NULL;
-	conf->oper_pass = NULL;
-	conf->allow_account_add = 1;
-	conf->configdir = g_strdup(CONFIG);
-	conf->plugindir = g_strdup(PLUGINDIR);
-	conf->pidfile = g_strdup(PIDFILE);
-	conf->motdfile = g_strdup(ETCDIR "/motd.txt");
+	conf->password = NULL;
+	conf->configdir = g_strdup( CONFIG );
+	conf->motdfile = g_strdup( ETCDIR "/motd.txt" );
 	conf->ping_interval = 180;
 	conf->ping_timeout = 300;
-	conf->user = NULL;
-	conf->ft_max_size = SIZE_MAX;
-	conf->ft_max_kbps = G_MAXUINT;
-	conf->ft_listen = NULL;
-	conf->protocols = NULL;
-	conf->cafile = NULL;
-	proxytype = 0;
-
-	i = conf_loadini(conf, global.conf_file);
-	if (i == 0) {
-		fprintf(stderr, "Error: Syntax error in configuration file `%s'.\n", global.conf_file);
-		conf_free(conf);
-		return NULL;
-	} else if (i == -1) {
-		config_missing++;
-		/* Whine after parsing the options if there was no -c pointing
-		   at a *valid* configuration file. */
-	}
-
-	while (argc > 0 && (opt = getopt(argc, argv, "i:p:P:nvIDFc:d:hu:V")) >= 0) {
-		/*     ^^^^ Just to make sure we skip this step from the REHASH handler. */
-		if (opt == 'i') {
-			conf->iface_in = g_strdup(optarg);
-		} else if (opt == 'p') {
-			g_free(conf->port);
-			conf->port = g_strdup(optarg);
-		} else if (opt == 'P') {
-			g_free(conf->pidfile);
-			conf->pidfile = g_strdup(optarg);
-		} else if (opt == 'n') {
-			conf->nofork = 1;
-		} else if (opt == 'v') {
-			conf->verbose = 1;
-		} else if (opt == 'I') {
-			conf->runmode = RUNMODE_INETD;
-		} else if (opt == 'D') {
-			conf->runmode = RUNMODE_DAEMON;
-		} else if (opt == 'F') {
-			conf->runmode = RUNMODE_FORKDAEMON;
-		} else if (opt == 'c') {
-			if (strcmp(global.conf_file, optarg) != 0) {
-				g_free(global.conf_file);
-				global.conf_file = g_strdup(optarg);
-				conf_free(conf);
-				/* Re-evaluate arguments. Don't use this option twice,
-				   you'll end up in an infinite loop! Hope this trick
-				   works with all libcs BTW.. */
-				optind = 1;
-				return conf_load(argc, argv);
-			}
-		} else if (opt == 'd') {
-			g_free(conf->configdir);
-			conf->configdir = g_strdup(optarg);
-		} else if (opt == 'h') {
-			printf("Usage: bitlbee [-D/-F [-i <interface>] [-p <port>] [-n] [-v]] [-I]\n"
-			       "               [-c <file>] [-d <dir>] [-x] [-h]\n"
-			       "\n"
-			       "An IRC-to-other-chat-networks gateway\n"
-			       "\n"
-			       "  -I  Classic/InetD mode. (Default)\n"
-			       "  -D  Daemon mode. (one process serves all)\n"
-			       "  -F  Forking daemon. (one process per client)\n"
-			       "  -u  Run daemon as specified user.\n"
-			       "  -P  Specify PID-file (not for inetd mode)\n"
-			       "  -i  Specify the interface (by IP address) to listen on.\n"
-			       "      (Default: 0.0.0.0 (any interface))\n"
-			       "  -p  Port number to listen on. (Default: 6667)\n"
-			       "  -n  Don't fork.\n"
-			       "  -v  Be verbose (only works in combination with -n)\n"
-			       "  -c  Load alternative configuration file\n"
-			       "  -d  Specify alternative user configuration directory\n"
-			       "  -x  Command-line interface to password encryption/hashing\n"
-			       "  -h  Show this help page.\n"
-			       "  -V  Show version info.\n");
-			conf_free(conf);
-			return NULL;
-		} else if (opt == 'V') {
-			printf("BitlBee %s\n", BITLBEE_VERSION);
-			/* the rest of the version string is displayed below, for ld -vvv compatibility*/
-			version_happened = TRUE;
-		} else if (opt == 'u') {
-			g_free(conf->user);
-			conf->user = g_strdup(optarg);
-		}
-	}
-
-	if (version_happened) {
-		printf("API version %06x\nConfigure args: %s\n",
-		       BITLBEE_VERSION_CODE, BITLBEE_CONFIGURE_ARGS);
-		conf_free(conf);
-		return NULL;
-	}
-
-	if (conf->configdir[strlen(conf->configdir) - 1] != '/') {
-		char *s = g_new(char, strlen(conf->configdir) + 2);
-
-		sprintf(s, "%s/", conf->configdir);
-		g_free(conf->configdir);
+	
+	i = conf_loadini( conf, CONF_FILE );
+	if( i == 0 )
+	{
+		fprintf( stderr, "Error: Syntax error in configuration file `%s'.\n", CONF_FILE );
+		return( NULL );
+	}
+	else if( i == -1 )
+	{
+		fprintf( stderr, "Warning: Unable to read configuration file `%s'.\n", CONF_FILE );
+	}
+	
+	while( ( opt = getopt( argc, argv, "i:p:nvIDc:d:h" ) ) >= 0 )
+	{
+		if( opt == 'i' )
+		{
+			conf->iface = g_strdup( optarg );
+		}
+		else if( opt == 'p' )
+		{
+			if( ( sscanf( optarg, "%d", &i ) != 1 ) || ( i <= 0 ) || ( i > 65535 ) )
+			{
+				fprintf( stderr, "Invalid port number: %s\n", optarg );
+				return( NULL );
+			}
+			conf->port = i;
+		}
+		else if( opt == 'n' )
+			conf->nofork=1;
+		else if( opt == 'v' )
+			conf->verbose=1;
+		else if( opt == 'I' )
+			conf->runmode=RUNMODE_INETD;
+		else if( opt == 'D' )
+			conf->runmode=RUNMODE_DAEMON;
+		else if( opt == 'c' )
+		{
+			if( strcmp( CONF_FILE, optarg ) != 0 )
+			{
+				g_free( CONF_FILE );
+				CONF_FILE = g_strdup( optarg );
+				g_free( conf );
+				return( conf_load( argc, argv ) );
+			}
+		}
+		else if( opt == 'd' )
+		{
+			g_free( conf->configdir );
+			conf->configdir = g_strdup( optarg );
+		}
+		else if( opt == 'h' )
+		{
+			printf( "Usage: bitlbee [-D [-i <interface>] [-p <port>] [-n] [-v]] [-I]\n"
+			        "               [-c <file>] [-d <dir>] [-h]\n"
+			        "\n"
+			        "An IRC-to-other-chat-networks gateway\n"
+			        "\n"
+			        "  -I  Classic/InetD mode. (Default)\n"
+			        "  -D  Daemon mode. (Still EXPERIMENTAL!)\n"
+			        "  -i  Specify the interface (by IP address) to listen on.\n"
+			        "      (Default: 0.0.0.0 (any interface))\n"
+			        "  -p  Port number to listen on. (Default: 6667)\n"
+			        "  -n  Don't fork.\n"
+			        "  -v  Be verbose (only works in combination with -n)\n"
+			        "  -c  Load alternative configuration file\n"
+			        "  -d  Specify alternative user configuration directory\n"
+			        "  -h  Show this help page.\n" );
+			return( NULL );
+		}
+	}
+	
+	if( conf->configdir[strlen(conf->configdir)-1] != '/' )
+	{
+		char *s = g_new( char, strlen( conf->configdir ) + 2 );
+		
+		sprintf( s, "%s/", conf->configdir );
+		g_free( conf->configdir );
 		conf->configdir = s;
 	}
-
-	if (config_missing) {
-		fprintf(stderr, "Warning: Unable to read configuration file `%s'.\n", global.conf_file);
-	}
-
-	if (conf->cafile && access(conf->cafile, R_OK) != 0) {
-		/* Let's treat this as a serious problem so people won't think
-		   they're secure when in fact they're not. */
-		fprintf(stderr, "Error: Could not read CA file %s: %s\n", conf->cafile, strerror(errno));
-		conf_free(conf);
-		return NULL;
-	}
-
-	return conf;
+	
+	return( conf );
 }
 
-static void conf_free(conf_t *conf)
-{
-	/* Free software means users have the four essential freedoms:
-	   0. to run the program,
-	   2. to study and change the program in source code form,
-	   2. to redistribute exact copies, and
-	   3. to distribute modified versions
-	*/
-	g_free(conf->auth_pass);
-	g_free(conf->cafile);
-	g_free(conf->configdir);
-	g_free(conf->ft_listen);
-	g_free(conf->hostname);
-	g_free(conf->iface_in);
-	g_free(conf->iface_out);
-	g_free(conf->motdfile);
-	g_free(conf->oper_pass);
-	g_free(conf->pidfile);
-	g_free(conf->plugindir);
-	g_free(conf->port);
-	g_free(conf->primary_storage);
-	g_free(conf->user);
-	g_strfreev(conf->migrate_storage);
-	g_strfreev(conf->protocols);
-	g_free(conf);
-
-}
-
-static int conf_loadini(conf_t *conf, char *file)
+static int conf_loadini( conf_t *conf, char *file )
 {
 	ini_t *ini;
 	int i;
-
-	ini = ini_open(file);
-	if (ini == NULL) {
-		return -1;
-	}
-	while (ini_read(ini)) {
-		if (g_strcasecmp(ini->section, "settings") == 0) {
-			if (g_strcasecmp(ini->key, "runmode") == 0) {
-				if (g_strcasecmp(ini->value, "daemon") == 0) {
+	
+	ini = ini_open( file );
+	if( ini == NULL ) return( -1 );
+	while( ini_read( ini ) )
+	{
+		if( g_strcasecmp( ini->section, "settings" ) == 0 )
+		{
+			if( g_strcasecmp( ini->key, "runmode" ) == 0 )
+			{
+				if( g_strcasecmp( ini->value, "daemon" ) == 0 )
 					conf->runmode = RUNMODE_DAEMON;
-				} else if (g_strcasecmp(ini->value, "forkdaemon") == 0) {
-					conf->runmode = RUNMODE_FORKDAEMON;
-				} else {
+				else
 					conf->runmode = RUNMODE_INETD;
-				}
-			} else if (g_strcasecmp(ini->key, "pidfile") == 0) {
-				g_free(conf->pidfile);
-				conf->pidfile = g_strdup(ini->value);
-			} else if (g_strcasecmp(ini->key, "daemoninterface") == 0) {
-				g_free(conf->iface_in);
-				conf->iface_in = g_strdup(ini->value);
-			} else if (g_strcasecmp(ini->key, "daemonport") == 0) {
-				g_free(conf->port);
-				conf->port = g_strdup(ini->value);
-			} else if (g_strcasecmp(ini->key, "clientinterface") == 0) {
-				g_free(conf->iface_out);
-				conf->iface_out = g_strdup(ini->value);
-			} else if (g_strcasecmp(ini->key, "authmode") == 0) {
-				if (g_strcasecmp(ini->value, "registered") == 0) {
+			}
+			else if( g_strcasecmp( ini->key, "daemoninterface" ) == 0 )
+			{
+				conf->iface = g_strdup( ini->value );
+			}
+			else if( g_strcasecmp( ini->key, "daemonport" ) == 0 )
+			{
+				if( ( sscanf( ini->value, "%d", &i ) != 1 ) || ( i <= 0 ) || ( i > 65535 ) )
+				{
+					fprintf( stderr, "Invalid port number: %s\n", ini->value );
+					return( 0 );
+				}
+				conf->port = i;
+			}
+			else if( g_strcasecmp( ini->key, "authmode" ) == 0 )
+			{
+				if( g_strcasecmp( ini->value, "registered" ) == 0 )
 					conf->authmode = AUTHMODE_REGISTERED;
-				} else if (g_strcasecmp(ini->value, "closed") == 0) {
+				else if( g_strcasecmp( ini->value, "closed" ) == 0 )
 					conf->authmode = AUTHMODE_CLOSED;
-				} else {
+				else
 					conf->authmode = AUTHMODE_OPEN;
-				}
-			} else if (g_strcasecmp(ini->key, "authbackend") == 0) {
-				if (g_strcasecmp(ini->value, "storage") == 0) {
-					conf->auth_backend = NULL;
-				} else if (g_strcasecmp(ini->value, "pam") == 0 ||
-				         g_strcasecmp(ini->value, "ldap") == 0) {
-					g_free(conf->auth_backend);
-					conf->auth_backend = g_strdup(ini->value);
-				} else {
-					fprintf(stderr, "Invalid %s value: %s\n", ini->key, ini->value);
-					return 0;
-				}
-			} else if (g_strcasecmp(ini->key, "authpassword") == 0) {
-				g_free(conf->auth_pass);
-				conf->auth_pass = g_strdup(ini->value);
-			} else if (g_strcasecmp(ini->key, "operpassword") == 0) {
-				g_free(conf->oper_pass);
-				conf->oper_pass = g_strdup(ini->value);
-			} else if (g_strcasecmp(ini->key, "allowaccountadd") == 0) {
-				if (!is_bool(ini->value)) {
-					fprintf(stderr, "Invalid %s value: %s\n", ini->key, ini->value);
-					return 0;
-				}
-				conf->allow_account_add = bool2int(ini->value);
-			} else if (g_strcasecmp(ini->key, "hostname") == 0) {
-				g_free(conf->hostname);
-				conf->hostname = g_strdup(ini->value);
-			} else if (g_strcasecmp(ini->key, "configdir") == 0) {
-				g_free(conf->configdir);
-				conf->configdir = g_strdup(ini->value);
-			} else if (g_strcasecmp(ini->key, "plugindir") == 0) {
-				g_free(conf->plugindir);
-				conf->plugindir = g_strdup(ini->value);
-			} else if (g_strcasecmp(ini->key, "motdfile") == 0) {
-				g_free(conf->motdfile);
-				conf->motdfile = g_strdup(ini->value);
-			} else if (g_strcasecmp(ini->key, "accountstorage") == 0 ||
-				   g_strcasecmp(ini->key, "account_storage") == 0) {
-				g_free(conf->primary_storage);
-				conf->primary_storage = g_strdup(ini->value);
-			} else if (g_strcasecmp(ini->key, "accountstoragemigrate") == 0 ||
-				   g_strcasecmp(ini->key, "account_storage_migrate") == 0) {
-				g_strfreev(conf->migrate_storage);
-				conf->migrate_storage = g_strsplit_set(ini->value, " \t,;", -1);
-			} else if (g_strcasecmp(ini->key, "pinginterval") == 0) {
-				if (sscanf(ini->value, "%d", &i) != 1) {
-					fprintf(stderr, "Invalid %s value: %s\n", ini->key, ini->value);
-					return 0;
+			}
+			else if( g_strcasecmp( ini->key, "authpassword" ) == 0 )
+			{
+				conf->password = g_strdup( ini->value );
+			}
+			else if( g_strcasecmp( ini->key, "hostname" ) == 0 )
+			{
+				conf->hostname = g_strdup( ini->value );
+			}
+			else if( g_strcasecmp( ini->key, "configdir" ) == 0 )
+			{
+				g_free( conf->configdir );
+				conf->configdir = g_strdup( ini->value );
+			}
+			else if( g_strcasecmp( ini->key, "motdfile" ) == 0 )
+			{
+				g_free( conf->motdfile );
+				conf->motdfile = g_strdup( ini->value );
+			}
+			else if( g_strcasecmp( ini->key, "pinginterval" ) == 0 )
+			{
+				if( sscanf( ini->value, "%d", &i ) != 1 )
+				{
+					fprintf( stderr, "Invalid %s value: %s\n", ini->key, ini->value );
+					return( 0 );
 				}
 				conf->ping_interval = i;
-			} else if (g_strcasecmp(ini->key, "pingtimeout") == 0) {
-				if (sscanf(ini->value, "%d", &i) != 1) {
-					fprintf(stderr, "Invalid %s value: %s\n", ini->key, ini->value);
-					return 0;
+			}
+			else if( g_strcasecmp( ini->key, "pingtimeout" ) == 0 )
+			{
+				if( sscanf( ini->value, "%d", &i ) != 1 )
+				{
+					fprintf( stderr, "Invalid %s value: %s\n", ini->key, ini->value );
+					return( 0 );
 				}
 				conf->ping_timeout = i;
-			} else if (g_strcasecmp(ini->key, "proxy") == 0) {
-				url_t *url = g_new0(url_t, 1);
-
-				if (!url_set(url, ini->value)) {
-					fprintf(stderr, "Invalid %s value: %s\n", ini->key, ini->value);
-					g_free(url);
-					return 0;
-				}
-
-				strncpy(proxyhost, url->host, sizeof(proxyhost));
-				strncpy(proxyuser, url->user, sizeof(proxyuser));
-				strncpy(proxypass, url->pass, sizeof(proxypass));
+			}
+			else if( g_strcasecmp( ini->key, "proxy" ) == 0 )
+			{
+				url_t *url = g_new0( url_t, 1 );
+				
+				if( !url_set( url, ini->value ) )
+				{
+					fprintf( stderr, "Invalid %s value: %s\n", ini->key, ini->value );
+					g_free( url );
+					return( 0 );
+				}
+				
+				strncpy( proxyhost, url->host, sizeof( proxyhost ) );
+				strncpy( proxyuser, url->user, sizeof( proxyuser ) );
+				strncpy( proxypass, url->pass, sizeof( proxypass ) );
 				proxyport = url->port;
-				if (url->proto == PROTO_HTTP) {
+				if( url->proto == PROTO_HTTP )
 					proxytype = PROXY_HTTP;
-				} else if (url->proto == PROTO_SOCKS4) {
+				else if( url->proto == PROTO_SOCKS4 )
 					proxytype = PROXY_SOCKS4;
-				} else if (url->proto == PROTO_SOCKS5) {
+				else if( url->proto == PROTO_SOCKS5 )
 					proxytype = PROXY_SOCKS5;
-				} else if (url->proto == PROTO_SOCKS4A) {
-					proxytype = PROXY_SOCKS4A;
-				}
-
-				g_free(url);
-			} else if (g_strcasecmp(ini->key, "user") == 0) {
-				g_free(conf->user);
-				conf->user = g_strdup(ini->value);
-			} else if (g_strcasecmp(ini->key, "ft_max_size") == 0) {
-				size_t ft_max_size;
-				if (sscanf(ini->value, "%zu", &ft_max_size) != 1) {
-					fprintf(stderr, "Invalid %s value: %s\n", ini->key, ini->value);
-					return 0;
-				}
-				conf->ft_max_size = ft_max_size;
-			} else if (g_strcasecmp(ini->key, "ft_max_kbps") == 0) {
-				if (sscanf(ini->value, "%d", &i) != 1) {
-					fprintf(stderr, "Invalid %s value: %s\n", ini->key, ini->value);
-					return 0;
-				}
-				conf->ft_max_kbps = i;
-			} else if (g_strcasecmp(ini->key, "ft_listen") == 0) {
-				g_free(conf->ft_listen);
-				conf->ft_listen = g_strdup(ini->value);
-			} else if (g_strcasecmp(ini->key, "protocols") == 0) {
-				g_strfreev(conf->protocols);
-				conf->protocols = g_strsplit_set(ini->value, " \t,;", -1);
-			} else if (g_strcasecmp(ini->key, "cafile") == 0) {
-				g_free(conf->cafile);
-				conf->cafile = g_strdup(ini->value);
-			} else {
-				fprintf(stderr, "Error: Unknown setting `%s` in configuration file (line %d).\n",
-				        ini->key, ini->line);
-				return 0;
+				
+				g_free( url );
+			}
+			else
+			{
+				fprintf( stderr, "Error: Unknown setting `%s` in configuration file.\n", ini->key );
+				return( 0 );
 				/* For now just ignore unknown keys... */
 			}
-		} else if (g_strcasecmp(ini->section, "defaults") != 0) {
-			fprintf(stderr, "Error: Unknown section [%s] in configuration file (line %d). "
-			        "BitlBee configuration must be put in a [settings] section!\n", ini->section,
-			        ini->line);
-			return 0;
-		}
-	}
-	ini_close(ini);
-
-	return 1;
+		}
+		else if( g_strcasecmp( ini->section, "defaults" ) != 0 )
+		{
+			fprintf( stderr, "Error: Unknown section [%s] in configuration file. "
+			                 "BitlBee configuration must be put in a [settings] section!\n", ini->section );
+			return( 0 );
+		}
+	}
+	ini_close( ini );
+	
+	return( 1 );
 }
 
-void conf_loaddefaults(irc_t *irc)
+void conf_loaddefaults( irc_t *irc )
 {
 	ini_t *ini;
-
-	ini = ini_open(global.conf_file);
-	if (ini == NULL) {
-		return;
-	}
-	while (ini_read(ini)) {
-		if (g_strcasecmp(ini->section, "defaults") == 0) {
-			set_t *s = set_find(&irc->b->set, ini->key);
-
-			if (s) {
-				if (s->def) {
-					g_free(s->def);
-				}
-				s->def = g_strdup(ini->value);
-			}
-		}
-	}
-	ini_close(ini);
+	
+	ini = ini_open( CONF_FILE );
+	if( ini == NULL ) return;
+	while( ini_read( ini ) )
+	{
+		if( g_strcasecmp( ini->section, "defaults" ) == 0 )
+		{
+			set_t *s = set_find( irc, ini->key );
+			
+			if( s )
+			{
+				if( s->def ) g_free( s->def );
+				s->def = g_strdup( ini->value );
+			}
+		}
+	}
+	ini_close( ini );
 }
Index: conf.h
===================================================================
--- conf.h	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ conf.h	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,3 +1,3 @@
-/********************************************************************\
+  /********************************************************************\
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
@@ -20,6 +20,6 @@
   You should have received a copy of the GNU General Public License with
   the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
-  if not, write to the Free Software Foundation, Inc., 51 Franklin St.,
-  Fifth Floor, Boston, MA  02110-1301  USA
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
 */
 
@@ -27,37 +27,25 @@
 #define __CONF_H
 
-typedef enum runmode { RUNMODE_DAEMON, RUNMODE_FORKDAEMON, RUNMODE_INETD } runmode_t;
+typedef enum runmode { RUNMODE_DAEMON, RUNMODE_INETD } runmode_t;
 typedef enum authmode { AUTHMODE_OPEN, AUTHMODE_CLOSED, AUTHMODE_REGISTERED } authmode_t;
 
-typedef struct conf {
-	char *iface_in, *iface_out;
-	char *port;
+typedef struct conf
+{
+	char *iface;
+	signed int port;
 	int nofork;
 	int verbose;
 	runmode_t runmode;
 	authmode_t authmode;
-	char *auth_backend;
-	char *auth_pass;
-	char *oper_pass;
-	int allow_account_add;
+	char *password;
 	char *hostname;
 	char *configdir;
-	char *plugindir;
-	char *pidfile;
 	char *motdfile;
-	char *primary_storage;
-	char **migrate_storage;
 	int ping_interval;
 	int ping_timeout;
-	char *user;
-	size_t ft_max_size;
-	int ft_max_kbps;
-	char *ft_listen;
-	char **protocols;
-	char *cafile;
 } conf_t;
 
-G_GNUC_MALLOC conf_t *conf_load(int argc, char *argv[]);
-void conf_loaddefaults(irc_t *irc);
+conf_t *conf_load( int argc, char *argv[] );
+void conf_loaddefaults( irc_t *irc );
 
 #endif
Index: crypting.c
===================================================================
--- crypting.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
+++ crypting.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -0,0 +1,244 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2002-2004 Sjoerd Hemminga and others                     *
+  \********************************************************************/
+
+/* A little bit of encryption for the users' passwords                  */
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+
+/* [WvG] This file can also be compiled into a stand-alone program
+   which can encode/decode BitlBee account files. The main() will be
+   included if CRYPTING_MAIN is defined. Or just do "make decode" and
+   the programs will be built. */
+
+#ifndef CRYPTING_MAIN
+#define BITLBEE_CORE
+#include "bitlbee.h"
+#include "irc.h"
+#include "md5.h"
+#include "crypting.h"
+#include <string.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+#else
+
+typedef struct irc
+{
+	char *password;
+} irc_t;
+
+#define set_add( a, b, c, d )
+#define set_find( a, b ) NULL
+
+#include "md5.h"
+#include "crypting.h"
+#include <string.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+#endif
+
+/*\
+ * [SH] Do _not_ call this if it's not entirely sure that it will not cause
+ * harm to another users file, since this does not check the password for
+ * correctness.
+\*/
+
+/* USE WITH CAUTION!
+   Sets pass without checking */
+void setpassnc (irc_t *irc, char *pass) {
+	if (!set_find (irc, "password"))
+		set_add (irc, "password", NULL, passchange);
+	
+	if (irc->password) g_free (irc->password);
+	
+	if (pass) {
+		irc->password = g_strdup (pass);
+		irc_usermsg (irc, "Password successfully changed");
+	} else {
+		irc->password = NULL;
+	}
+}
+
+char *passchange (irc_t *irc, void *set, char *value) {
+	setpassnc (irc, value);
+	return (NULL);
+}
+
+int setpass (irc_t *irc, char *pass, char* md5sum) {
+	md5_state_t md5state;
+	md5_byte_t digest[16];
+	int i, j;
+	char digits[3];
+	
+	md5_init (&md5state);
+	md5_append (&md5state, (unsigned char *)pass, strlen (pass));
+	md5_finish (&md5state, digest);
+	
+	for (i = 0, j = 0; i < 16; i++, j += 2) {
+		/* Check password for correctness */
+		g_snprintf (digits, sizeof (digits), "%02x\n", digest[i]);
+		
+		if (digits[0] != md5sum[j]) return (-1);
+		if (digits[1] != md5sum[j + 1]) return (-1);
+	}
+	
+	/* If pass is correct, we end up here and we set the pass */
+	setpassnc (irc, pass);
+	
+	return (0);
+}
+
+char *hashpass (irc_t *irc) {
+	md5_state_t md5state;
+	md5_byte_t digest[16];
+	int i;
+	char digits[3];
+	char *rv;
+	
+	if (irc->password == NULL) return (NULL);
+	
+	rv = (char *)g_malloc (33);
+	memset (rv, 0, 33);
+	
+	md5_init (&md5state);
+	md5_append (&md5state, (unsigned char *)irc->password, strlen (irc->password));
+	md5_finish (&md5state, digest);
+	
+	for (i = 0; i < 16; i++) {
+		/* Build a hash of the pass */
+		g_snprintf (digits, sizeof (digits), "%02x", digest[i]);
+		strcat (rv, digits);
+	}
+	
+	return (rv);
+}
+
+char *obfucrypt (irc_t *irc, char *line) {
+	int i, j;
+	char *rv;
+	
+	if (irc->password == NULL) return (NULL);
+	
+	rv = (char *)g_malloc (strlen (line) + 1);
+	memset (rv, '\0', strlen (line) + 1);
+	
+	i = j = 0;
+	while (*line) {
+		/* Encrypt/obfuscate the line, using the password */
+		if (*(signed char*)line < 0) *line = - (*line);
+		if (((signed char*)irc->password)[i] < 0) irc->password[i] = - irc->password[i];
+		
+		rv[j] = *line + irc->password[i]; /* Overflow intended */
+		
+		line++;
+		if (!irc->password[++i]) i = 0;
+		j++;
+	}
+	
+	return (rv);
+}
+
+char *deobfucrypt (irc_t *irc, char *line) {
+	int i, j;
+	char *rv;
+	
+	if (irc->password == NULL) return (NULL);
+	
+	rv = (char *)g_malloc (strlen (line) + 1);
+	memset (rv, '\0', strlen (line) + 1);
+	
+	i = j = 0;
+	while (*line) {
+		/* Decrypt/deobfuscate the line, using the pass */
+		rv[j] = *line - irc->password[i]; /* Overflow intended */
+		
+		line++;
+		if (!irc->password[++i]) i = 0;
+		j++;
+	}
+	
+	return (rv);
+}
+
+#ifdef CRYPTING_MAIN
+
+/* A little main() function for people who want a stand-alone program to
+   encode/decode BitlCrypted files. */
+
+int main( int argc, char *argv[] )
+{
+	irc_t *irc = g_malloc( sizeof( irc_t ) );
+	char *hash, *action, line[256];
+	char* (*func)( irc_t *, char * );
+	
+	if( argc < 2 )
+	{
+		fprintf( stderr, "Usage: %s <password>\n\n"
+		                 "Reads from stdin, writes to stdout.\n"
+		                 "Call as \"encode\" to encode, \"decode\" to decode.\n", argv[0] );
+		return( 1 );
+	}
+	
+	memset( irc, 0, sizeof( irc_t ) );
+	irc->password = g_strdup( argv[1] );
+	
+	hash = hashpass( irc );
+	action = argv[0] + strlen( argv[0] ) - strlen( "encode" );
+	
+	if( strcmp( action, "encode" ) == 0 )
+	{
+		fwrite( hash, 32, 1, stdout );
+		func = obfucrypt;
+	}
+	else if( strcmp( action, "decode" ) == 0 )
+	{
+		char hash2[32];
+		
+		fread( hash2, 32, 1, stdin );
+		if( memcmp( hash, hash2, 32 ) != 0 )
+		{
+			fprintf( stderr, "Passwords don't match. Can't decode.\n" );
+			return( 1 );
+		}
+		func = deobfucrypt;
+	}
+	else
+	{
+		return( main( 0, NULL ) );
+	}
+	
+	while( fscanf( stdin, "%[^\n]255s", line ) > 0 )
+	{
+		char *out;
+		
+		/* Flush the newline */
+		fgetc( stdin );
+		
+		out = func( irc, line );
+		printf( "%s\n", out );
+		g_free( out );
+	}
+	
+	return( 0 );
+}
+
+#endif
Index: crypting.h
===================================================================
--- crypting.h	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
+++ crypting.h	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -0,0 +1,31 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2002-2004 Sjoerd Hemminga and others                     *
+  \********************************************************************/
+
+/* A little bit of encryption for the users' passwords                  */
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+
+void setpassnc (irc_t *irc, char *pass); /* USE WITH CAUTION! */
+char *passchange (irc_t *irc, void *set, char *value);
+int setpass (irc_t *irc, char *pass, char* md5sum);
+char *hashpass (irc_t *irc);
+char *obfucrypt (irc_t *irc, char *line);
+char *deobfucrypt (irc_t *irc, char *line);
Index: debian/README.Debian
===================================================================
--- debian/README.Debian	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ debian/README.Debian	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,3 +1,7 @@
-Fire up your favourite IRC client and connect to localhost:6667,
+Debconf should have asked you on what port you want BitlBee to run. If it
+did not, the port number is 6667 or 6668. (6668 if you already got an ircd
+running at 6667)
+
+Fire up your favourite IRC client and connect to localhost:6667 (or 6668),
 and read the documentation (type help for a list of commands).
 
Index: debian/bitlbee.conffiles
===================================================================
--- debian/bitlbee.conffiles	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
+++ debian/bitlbee.conffiles	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -0,0 +1,2 @@
+/etc/bitlbee/motd.txt
+/etc/bitlbee/bitlbee.conf
Index: debian/bitlbee.postinst
===================================================================
--- debian/bitlbee.postinst	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ debian/bitlbee.postinst	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,14 +1,22 @@
-#!/bin/sh
-set -e
+#!/bin/sh -e
 
-# Replace documentation directory with symlink
-docdir="/usr/share/doc/bitlbee"
-if [ -d $docdir ] && [ ! -L $docdir ]; then
-    if rmdir $docdir 2>/dev/null; then
-        ln -sf bitlbee-common $docdir
-    fi
+. /usr/share/debconf/confmodule
+
+db_get bitlbee/serveport
+PORT="$RET"
+
+TCPD='/usr/sbin/tcpd'
+CONFDIR=/var/lib/bitlbee/
+
+update-inetd --remove '/usr/sbin/bitlbee.*$'
+if [ -n "$PORT" ]; then
+	update-inetd --group OTHER --add "$PORT"'\tstream\ttcp\tnowait\tbitlbee\t'"$TCPD"'\t/usr/sbin/bitlbee'
 fi
 
-#DEBHELPER#
+if [ -d $CONFDIR ] && chown bitlbee $CONFDIR; then
+	echo 'BitlBee (probably) already installed, skipping user/configdir installation'
+	exit 0;
+fi
 
-exit 0
+adduser --system --home /var/lib/bitlbee/ --disabled-login --disabled-password bitlbee
+chmod 700 /var/lib/bitlbee/
Index: debian/bitlbee.postrm
===================================================================
--- debian/bitlbee.postrm	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
+++ debian/bitlbee.postrm	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -0,0 +1,12 @@
+#!/bin/sh -e
+
+[ "$1" = "purge" ] || exit 0
+
+if [ -e /usr/share/debconf/confmodule ]; then
+	. /usr/share/debconf/confmodule;
+	db_purge;
+fi
+
+update-inetd --remove '/usr/sbin/bitlbee.*$'
+
+deluser --remove-home bitlbee || true
